/* ****************************************************************************

  observucho offline Version 1.11 - Behavioral Recording System -

          last update 2010/11/17.
          Copyright (C) 2010 Laboratory of Applied Entomology,
	  Graduate School of Life and Environmental Sciences,
	  Kyoto Prefectural University 
	  & 
	  Fieldeast. 
	  All rights reserved.

	  http://www2.kpu.ac.jp/English/index.html
	  http://www.fieldeast.com/

**************************************************************************** */

var log = "";
var lasttime = "";
var lastkey = "";
var lastaction = "";
var lastnote = "";
var lastdate = "";
var cancelflag = false;
var startflag = false;			// L^tO
var startdate = new Date();		// L^
var endflag = false;			// ItO
var enddate = new Date();		// I

window.onload = function() {
	document.getElementById("keyaction1").innerHTML = keyAction1;
	document.getElementById("keyaction1").style.background = keyColor1;
	document.getElementById("keyaction2").innerHTML = keyAction2;
	document.getElementById("keyaction2").style.background = keyColor2;
	document.getElementById("keyaction3").innerHTML = keyAction3;
	document.getElementById("keyaction3").style.background = keyColor3;
	document.getElementById("keyaction4").innerHTML = keyAction4;
	document.getElementById("keyaction4").style.background = keyColor4;
	document.getElementById("keyaction5").innerHTML = keyAction5;
	document.getElementById("keyaction5").style.background = keyColor5;
	document.getElementById("keyaction6").innerHTML = keyAction6;
	document.getElementById("keyaction6").style.background = keyColor6;
	document.getElementById("keyaction7").innerHTML = keyAction7;
	document.getElementById("keyaction7").style.background = keyColor7;
	document.getElementById("keyaction8").innerHTML = keyAction8;
	document.getElementById("keyaction8").style.background = keyColor8;
	document.getElementById("keyaction9").innerHTML = keyAction9;
	document.getElementById("keyaction9").style.background = keyColor9;
	document.getElementById("csvarea").value = "";
	document.getElementById("tsvarea").value = "";
}

document.onkeydown = function(e) {
	var shift;
	if (e != null) {
		keycode = e.which;
		// ctrl = typeof e.modifiers == 'undefined' ? e.ctrlKey : e.modifiers & Event.CONTROL_MASK;
		// shift = typeof e.modifiers == 'undefined' ? e.shiftKey : e.modifiers & Event.SHIFT_MASK;
		e.preventDefault();
		e.stopPropagation();
	} else {
		keycode = event.keyCode;
		// ctrl = event.ctrlKey;
		// shift = event.shiftKey;
		event.returnValue = false;
		event.cancelBubble = true;
	}
	keychar = String.fromCharCode(keycode).toUpperCase();
	setaction( keychar, keycode );
}

function setaction( keychar, keycode ) {
	if(( keychar == "0" ) || ( keycode == 48 ) || ( keycode == 96 )){
		if( startflag == false ){
			return;
		}
		keychar = "0";
		cancelflag = true;
		return;
	}
	else if(( keychar == "1" ) || ( keycode == 49 ) || ( keycode == 97 )){
		keychar = "1";
		action = keyAction1;
		bgcolor = keyColor1;
	}
	else if(( keychar == "2" ) || ( keycode == 50 ) || ( keycode == 98 )){
		keychar = "2";
		action = keyAction2;
		bgcolor = keyColor2;
	}
	else if(( keychar == "3" ) || ( keycode == 51 ) || ( keycode == 99 )){
		keychar = "3";
		action = keyAction3;
		bgcolor = keyColor3;
	}
	else if(( keychar == "4" ) || ( keycode == 52 ) || ( keycode == 100 )){
		keychar = "4";
		action = keyAction4;
		bgcolor = keyColor4;
	}
	else if(( keychar == "5" ) || ( keycode == 53 ) || ( keycode == 101 )){
		keychar = "5";
		action = keyAction5;
		bgcolor = keyColor5;
	}
	else if(( keychar == "6" ) || ( keycode == 54 ) || ( keycode == 102 )){
		keychar = "6";
		action = keyAction6;
		bgcolor = keyColor6;
	}
	else if(( keychar == "7" ) || ( keycode == 55 ) || ( keycode == 103 )){
		keychar = "7";
		action = keyAction7;
		bgcolor = keyColor7;
	}
	else if(( keychar == "8" ) || ( keycode == 56 ) || ( keycode == 104 )){
		keychar = "8";
		action = keyAction8;
		bgcolor = keyColor8;
	}
	else if(( keychar == "9" ) || ( keycode == 57 ) || ( keycode == 105 )){
		keychar = "9";
		action = keyAction9;
		bgcolor = keyColor9;
	}
	else{
		return;
	}
	if( action == "" ){
		return;
	}

	if( cancelflag ){
		lastnote = "revised";
		if( lastkey != "" ){
			lastnote = lastnote + "(" + lastkey + ")";
		}
		cancelflag = false;
	}
	else{
		var now = new Date();

		if( startflag == false ){	// ̏
			startflag = true;
			startdate = now;
			if(( dur_mm != 0 ) || ( dur_ss != 0 )){
				var startsec = startdate.getTime();
				var endsec = startsec + ( dur_mm * 60 * 1000 ) + ( dur_ss * 1000 );
				enddate.setTime( endsec );

				if( dur_ss < 10 ){
					dur_ss = "0" + ( dur_ss * 1 );
				}
			}
		}

		if( lastdate != "" ){
			diff = now.getTime() - lastdate.getTime();
			diffd = diff % 1000;
			diffd = diffd + "00";
			diffd = diffd.substr( 0, 2 );
			diff = Math.floor( diff / 1000 );
			diffm = Math.floor( diff / 60 );
			diffs = diff % 60;
			if( diffm < 10 ) { diffm = "0" + diffm; }
			if( diffs < 10 ) { diffs = "0" + diffs; }
			duration = diffm + ":" + diffs + "." + diffd;
		}
		else{
			duration = "";
		}

		if( lasttime != "" ){
			log = log + lasttime + "," + lastkey + "," + lastaction + "," + duration + "," + lastnote + "\n";
		}

		if(( now.getTime() > enddate.getTime()) && ( endflag == false ) && (( dur_mm != 0 ) || ( dur_ss != 0 ))){
			diff = enddate.getTime() - lastdate.getTime();
			diffd = diff % 1000;
			diffd = diffd + "00";
			diffd = diffd.substr( 0, 2 );
			diff = Math.floor( diff / 1000 );
			diffm = Math.floor( diff / 60 );
			diffs = diff % 60;
			if( diffm < 10 ) { diffm = "0" + diffm; }
			if( diffs < 10 ) { diffs = "0" + diffs; }
			endduration = diffm + ":" + diffs + "." + diffd;

			log = log + endtime + ",-,-" + "," + endduration + "," + dur_mm + "' " + dur_ss + "\"\n";

			endflag = true;
		}

		lastdate = now;

		var hh = now.getHours();
		var mm = now.getMinutes();
		var ss = now.getSeconds();
		var dd = now.getMilliseconds();

		if( hh < 10 ) { hh = "0" + hh; }
		if( mm < 10 ) { mm = "0" + mm; }
		if( ss < 10 ) { ss = "0" + ss; }
		if( dd < 10 ) { dd = "0" + dd; }

		dd = dd + "00";
		dd = dd.substr( 0, 2 );

		lasttime = hh + ":" + mm + ":" + ss + "." + dd;
		lastnote = "";
	}

	document.getElementById("currenttext").innerHTML = action;
	document.getElementById("currenttext").style.color = "#ffffff";
	document.getElementById("currentbox").style.background = bgcolor;

	lastkey = keychar;
	lastaction = action;

	logtable = "<table cellspacing=2 cellpadding=2 class=\"logtable\"><tr><th class=\"logtableth\">No.</th><th class=\"logtableth\">Time</th><th class=\"logtableth\">Key</th><th class=\"logtableth\">Event</th><th class=\"logtableth\">Duration</th><th class=\"logtableth\">Note</th></tr>";

	if(( endflag == false ) && (( dur_mm != 0 ) || ( dur_ss != 0 ))){
		var end_hh = enddate.getHours();
		var end_mm = enddate.getMinutes();
		var end_ss = enddate.getSeconds();
		var end_dd = enddate.getMilliseconds();
		if( end_hh < 10 ) { end_hh = "0" + end_hh; }
		if( end_mm < 10 ) { end_mm = "0" + end_mm; }
		if( end_ss < 10 ) { end_ss = "0" + end_ss; }
		if( end_dd < 10 ) { end_dd = "0" + end_dd; }
		end_dd = end_dd + "00";
		end_dd = end_dd.substr( 0, 2 );
		endtime = end_hh + ":" + end_mm + ":" + end_ss + "." + end_dd;

		logtable = logtable + "<tr>";
		logtable = logtable + "<td class=\"logtabletd3\"></td>";
		logtable = logtable + "<td align=\"center\" class=\"logtabletd3\">" + endtime + "</td>";
		logtable = logtable + "<td class=\"logtabletd3\"></td>";
		logtable = logtable + "<td class=\"logtabletd3\"></td>";
		logtable = logtable + "<td class=\"logtabletd3\"></td>";
		logtable = logtable + "<td class=\"logtabletd3\">" + dur_mm + "' " + dur_ss + "\"</td>";
		logtable = logtable + "</tr>";
	}

	templog = log + lasttime + "," + lastkey + "," + lastaction + "," + "" + "," + lastnote + "\n";
	logline = templog.split("\n");

	for( var i = logline.length - 2; i >= 0; i-- )
	{
		logdata = logline[i].split(",");
		var no = i + 1;

		if( logdata[1] == "-" ){
			tdclass = "logtabletd3";
		}
		else if( i % 2 == 0 ){
			tdclass = "logtabletd1";
		}
		else{
			tdclass = "logtabletd2";
		}

		logtable = logtable + "<tr>";
		logtable = logtable + "<td align=\"right\" class=\"" + tdclass + "\">" + no + "</td>";
		logtable = logtable + "<td class=\"" + tdclass + "\">" + logdata[0] + "</td>";
		logtable = logtable + "<td align=\"center\" class=\"" + tdclass + "\">" + logdata[1] + "</td>";
		logtable = logtable + "<td align=\"center\" class=\"" + tdclass + "\">" + logdata[2] + "</td>";
		logtable = logtable + "<td align=\"center\" class=\"" + tdclass + "\">" + logdata[3] + "</td>";
		logtable = logtable + "<td class=\"" + tdclass + "\">" + logdata[4] + "</td>";
		logtable = logtable + "</tr>";
	}
	logtable = logtable + "</table>";
	document.getElementById("logbox").innerHTML = logtable;

	csvlog = "No.,Time,Key,Event,Duration,Note\n";
	logline = templog.split("\n");
	for( var i = 0; i < logline.length - 1; i++ )
	{
		logdata = logline[i].split(",");
		var no = i + 1;
		csvlog = csvlog + no + "," + logdata[0] + "," + logdata[1] + "," + logdata[2] + "," + logdata[3] + "," + logdata[4] + "\n";
	}

	document.getElementById("csvarea").value = csvlog;
	var tsvlog = csvlog.replace(/,/g, "\t");
	document.getElementById("tsvarea").value = tsvlog;
}

/* ************************************************************************* */
